<template>
    <div class="app-address-cascader">
        <el-cascader popper-class="app-address-cascader__popper-class" :disabled="disabled" size="medium"
            v-model="CurrentVal" :options="items" separator=" - " @expand-change="selectChange" @change="nodeChange"
            @visible-change="onChange">
            <template slot-scope="{ node, data }">
                <div :class="{ 'selected-node': isSelect(data.value) }">
                    <span v-if="!node.isLeaf" class="node__icon">
                        <img src="@/assets/img/dropdown-icon.svg" v-if="isSelect(data.value)">
                        <img src="@/assets/img/select-right-icon.svg" v-else>
                    </span>
                    <span class="cascader-node-label">{{ data.label }}</span>
                </div>
            </template>
        </el-cascader>
    </div>
</template>

<script lang="ts">
import { Component, Vue, Prop} from 'vue-property-decorator';
import CodeListService from '@/codelist/codelist-service';
@Component({})
export default class AppAddressCascader extends Vue {

    /**
     * 属性名称
     *
     * @type {*}
     * @memberof AppCheckBox
 */
    @Prop() name?: any;

    /**
      * 传入值
      * @type {any}
      * @memberof AppAddressCascader
      */
    @Prop() public value?: any;

    /**
     * 是否禁用
     * @type {boolean}
     * @memberof AppAddressCascader
     */
    @Prop() public disabled?: boolean;

    /**
     * 代码表标识
     *
     * @type {string}
     * @memberof AppAddressCascader
     */
    @Prop() public tag?: string;

    /**
    * 局部上下文导航参数
    *
    * @type {any}
    * @memberof AppCheckBox
    */
    @Prop() public localContext!: any;

    /**
     * 局部导航参数
     *
     * @type {any}
     * @memberof AppCheckBox
     */
    @Prop() public localParam!: any;

    /**
     * 传入表单数据
     *
     * @type {*}
     * @memberof AppCheckBox
     */
    @Prop() public data?: any;

    /**
     * 视图上下文
     *
     * @type {*}
     * @memberof AppCheckBox
     */
    @Prop() public context!: any;

    /**
     * 代码表类型
     *
     * @type {string}
     * @memberof AppAddressCascader
     */
    @Prop() public codelistType?: string;

    /**
     * 视图参数
     *
     * @type {*}
     * @memberof AppCheckBox
     */
    @Prop() public viewparams!: any;

    /**
     * 代码表服务对象
     *
     * @type {CodeListService}
     * @memberof AppAddressCascader
     */
    public codeListService: CodeListService = new CodeListService();
    
    //判断是否被选中
    isSelect(value: any) {
        if (this.selectNode.indexOf(value) < 0) {
            return false;
        } else {
            return true;
        }
    }

    /**
     * 当前值
     *
     * @memberof AppAddressCascader
     */
    get CurrentVal() {
        return this.value;
    }

    /**
      * 值变化
      *
      * @memberof AppAddressCascader
      */
    set CurrentVal(val: any) {
        this.$emit("change", {name:this.name,value:val[val.length-1]});
    }



    /**
      * 城市数据
      *
      * @memberof AppAddressCascader
      */
    public items: any = [];

    public selectNode: any[] = [];

    /**
      * 获取树形代码表数据
      *
      * @memberof AppAddressCascader
      */
    public load() {
        if (this.tag) {
            if (Object.is(this.codelistType, "STATIC")) {
                const codelist = this.$store.getters.getCodeList(this.tag);
                if (codelist) {
                    this.formatData([...JSON.parse(JSON.stringify(codelist.items))]);
                } else {
                    console.warn(`${this.tag}--代码表配置异常`);
                }
            } else if (Object.is(this.codelistType, "DYNAMIC")) {
                // 公共参数处理
                let data: any = {};
                this.handlePublicParams(data);
                // 参数处理
                let _context = data.context;
                let _param = data.param;
                this.codeListService.getItems(this.tag, _context, _param).then((res: any) => {
                    this.formatData([...JSON.parse(JSON.stringify(res))]);
                }).catch((error: any) => {
                    console.error(error);
                });
            }
        }

    }
    /**
     * 公共参数处理
     *
     * @param {*} arg
     * @returns
     * @memberof AppCheckBox
     */
    public handlePublicParams(arg: any) {
        // 合并表单参数
        arg.param = this.viewparams ? JSON.parse(JSON.stringify(this.viewparams)) : {};
        arg.context = this.context ? JSON.parse(JSON.stringify(this.context)) : {};
        // 附加参数处理
        if (this.localContext && Object.keys(this.localContext).length > 0) {
            let _context = this.$util.computedNavData(this.data, arg.context, arg.param, this.localContext);
            Object.assign(arg.context, _context);
        }
        if (this.localParam && Object.keys(this.localParam).length > 0) {
            let _param = this.$util.computedNavData(this.data, arg.param, arg.param, this.localParam);
            Object.assign(arg.param, _param);
        }
    }

    //展开面板 
    public onChange(value: boolean) {
        if (value) {
            this.load()
        }
    }

    //格式化代码表
    public formatData(data: any[]) {
        if (data.length == 0) {
            this.items = []
        } else {
            this.items = this.handleChildren(undefined, data);
        }
    }

    //处理父子层级
    public handleChildren(pValue: any, data: any) {
        let tempData: any[] = [];
        data.forEach((item: any, index: number) => {
            if (Object.is(pValue, item.pvalue)) {
                tempData.push(...data.splice(index, 1));
            }
        })

        tempData.forEach((item: any) => {
            const children = this.handleChildren(item.value, data);
            if (children.length == 0) {
                return
            }
            if (item.children) {
                item.children.push(...children);
            } else {
                item.children = children;
            }
        })
        return tempData;
    }

    //选中树节点改变
    public selectChange(data: any) {
        this.selectNode = data;
    }

    //选中叶子值改变
    public nodeChange(data:any){
        this.selectNode = data;
    }

    /**
   * 生命周期
   *
   * @memberof AppAddressCascader
   */
    public created() {
        this.load();
    }
}
</script>

<style lang="scss">
@import "./app-address-cascader.scss";
</style>
